#pragma once
#include "config.h"
#include <msctf.h>
#include "TSFTextStore.h"
using namespace WebCore;
class TSFEventRouter
{
public:
	TSFEventRouter(void);
	virtual ~TSFEventRouter(void);
	
	void SetFrame(RefPtr<WebCore::Frame> m_frame, HWND hWnd);

	BOOL SelectionChange(HWND hWnd);
	
	ITfThreadMgr* m_pThreadMgr;
	TfClientId m_tfClientId;
	ITfKeystrokeMgr* m_pKeystoreMgr;

	ITfDocumentMgr* m_document_manger;
	ITfContext* m_context;

	TfEditCookie m_ecTextStore;
	TSFTextStore* m_textStore;
	DWORD m_dwTextEditSinkCookie;

	RefPtr<WebCore::Frame> m_frame;
	HWND m_hWnd;
	BOOL m_bInitiated;

	VOID Initialize();
	VOID Finalize();
	VOID AddWindow(HWND hWnd);
	INT DeleteWindow(HWND hWnd);
	typedef struct {
		HWND hWnd;
		ITfDocumentMgr* pDocumentMgr;
		ITfContext* pContext;
		ITfDocumentMgr* pPrevDocmentMgr;
		TSFTextStore* pTextStore;
		DWORD dwTextEditSinkCookie;
	} HWND_TSF_INFO;
	Vector<HWND_TSF_INFO*> m_HwndTSFInfoVec;
	HWND_TSF_INFO* FindInfo(HWND hWnd);
};
