//
// Copyright (c) 2011 NEC Corporation. All rights reserved.
//

#pragma once

#include "stdio.h"
#include <tchar.h>
#include <yvals.h>
#include <psapi.h>

#define MYDEBUG 1
#ifdef MYDEBUG
extern volatile int iPrintDebugState;	/* -2:busy, 0:never print, 1:only js print, 2: all print */
static void PrintDebugMessage(LPCTSTR funcname, int line, LPCTSTR str, ...) {
    TCHAR cbuf[1024];
    TCHAR fmt[256];
	TCHAR *mbuf = cbuf;

	SYSTEMTIME ltm;
	int iTmpEnableDebugPrint;
	if (iPrintDebugState < 0) return;
	iTmpEnableDebugPrint = iPrintDebugState;
	iPrintDebugState = -2;

	GetLocalTime(&ltm);
	MEMORYSTATUSEX msex = { sizeof(MEMORYSTATUSEX) };
	GlobalMemoryStatusEx( &msex );
    DWORD dwMemSize = (DWORD)(msex.ullTotalVirtual - msex.ullAvailVirtual);
	va_list arg;
    va_start(arg, str);
    int iLen = _stprintf_s(fmt, 255, _T("%02d:%02d:%02d, MEM(VirtualBytes / MemoryLoad)= %d KB / %d, %s(%d):%s"), ltm.wHour, ltm.wMinute, ltm.wSecond, (dwMemSize / 1024), msex.dwMemoryLoad, funcname, line, str);
	if (iLen < 0) iLen = 0;
	fmt[iLen] = 0;

	iLen = _vscwprintf( fmt, arg ) + 1;	// add for null terminate
	if (iLen > 1024) {
		mbuf = (TCHAR*)malloc(iLen * sizeof(TCHAR));
	} 
	int iLen2 = vswprintf_s(mbuf, iLen, fmt, arg);	// iLen𒴂ꍇAPG[𔭐Ă邾I
	if (iLen2 < 0) iLen2 = 0;
	mbuf[iLen2] = 0;
    OutputDebugString( cbuf );
	if (iLen > 1024) {
		free(mbuf);
	}

    va_end(arg);
	iPrintDebugState = iTmpEnableDebugPrint;
}

#define MYDEBUGMSG( str, ... )  {\
	if (iPrintDebugState == -2) \
		OutputDebugStringA("#### Another Thread is Blokking DebugPrint !! ####\n"); \
	else \
		if (iPrintDebugState == 2) PrintDebugMessage(__FUNCTIONW__, __LINE__, str, __VA_ARGS__); }

//#define WLDEBUGMSG    MYDEBUGMSG
#define WLDEBUGMSG( str, ... )      ((void)0)

#else

#define MYDEBUGMSG(str, ... )		((void)0)
#define WLDEBUGMSG( str, ... )      ((void)0)

#endif
