/*
 * Copyright (C) 2006, 2008 Apple Computer, Inc.  All rights reserved.
 * Copyright (C) 2009, 2011 Brent Fulgham.  All rights reserved.
 * Copyright (C) 2009, 2010, 2011 Appcelerator, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE COMPUTER, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE COMPUTER, INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

#include "stdafx.h"
#include "WinLauncher.h"

#include "DOMDefaultImpl.h"
#include "PrintWebUIDelegate.h"
#include "PrintWebUIDelegatePrivate2.h"
#include <WebKit/WebKitCOMAPI.h>

#include <commctrl.h>
#include <commdlg.h>
#include <objbase.h>
#include <shellapi.h>
#include <shlwapi.h>
#include <string>
#include <wininet.h>
#include <Shlobj.h>
#include <tpcshrd.h>

#define WLCACHE 1

#define MAX_LOADSTRING 100
#define URLBAR_HEIGHT  24

#define TIMER_ID1 1
#define TIMER_ID2 2
#define TIMER_ID3 3
#define TIMER_ID4 4
#define YAHOO_INTERVAL 5000
#define YAHOO_LOG_INTERVAL 1
volatile int iFinishLoadForFrame = 0;
int iCaptureEnable = 0;	/* exec Capture on WebCapture */
int iLoadWaitTime = 5000;

#define WM_ERR_WININET	(WM_USER+1)
#define WM_ERR_UIDELEGATE (WM_USER+2)
#define WM_ERR_UIDELEGATEPRIVATE2 (WM_USER+3)
#define ERR_RESOURCE_LOAD	1
#define ERR_FRAME_LOAD	2
#define ERR_FRAME_PROV_LOAD	3

#define USER_AGENT_DEFAULT L"Mozilla/5.0 (Windows; U; Windows NT 6.1; en-us) AppleWebKit/534.52.7 (KHTML, like Gecko) Version/5.1 Safari/534.52.7"
BSTR bstUserAgent = NULL;
BSTR bstUserAgentSpecial1 = NULL;
TCHAR szUrlPatternSpecial1[255] = {0};

#ifdef MYDEBUG
volatile int iPrintDebugState = 2;	/* -2:busy, 0:never print, 1:only js print, 2: all print */
#endif

int cntTestSite = 0;
TCHAR* urlTestSite[255] = {NULL};
int posTestSite = -1;
DWORD cntLoopTestSite;

// {Ȃ畡WebViewpɈȉarray or vector̕Kv
static volatile IWebView* haveSWFWebView = 0;

// Global Variables:
HINSTANCE hInst;                                // current instance
//HMENU hMenu;
HWND hMainWnd;
HWND hURLBarWnd;
WNDPROC DefEditProc = 0;
WNDPROC DefWebKitProc = 0;
IWebView* gWebView = 0;
IWebIBActions* gWebActions = 0;
IWebPreferences* standardPreferences = 0;

IWebCache* gWebCache = 0;
IWebViewPrivate* gWebViewPrivate = 0;
IWebInspector* gWebInspector = 0;
HWND gViewWindow = 0;
WinLauncherWebHost* gWebHost = 0;
WinLauncherWebResLoad* gWebresLoad = 0;
WinLauncherWebPolicy* gWebpolicy = 0;
PrintWebUIDelegate* gPrintDelegate = 0;
PrintWebUIDelegatePrivate2* gPrintDelegatePrivate2 = 0;
TCHAR szTitle[MAX_LOADSTRING];                    // The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];            // the main window class name

TCHAR g_szLocalTestUrl[MAX_PATH] = _T("");
UINT_PTR g_nIDEvent = 0;

// Support moving the transparent window
POINT s_windowPosition = { 100, 100 };
SIZE s_windowSize = { 800, 400 };
bool s_usesLayeredWebView = false;
bool s_fullDesktop = false;
int iYahooMode = 0;	// 0=NoYahoo, 1=Yohoo(NoDelay), 2=Yahoo(1s Delay)
unsigned int iYahooCounter = 0;

// Forward declarations of functions included in this code module:
ATOM                MyRegisterClass(HINSTANCE hInstance);
LRESULT CALLBACK    WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK    About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK    MyEditProc(HWND, UINT, WPARAM, LPARAM);

BOOL GetBaseUrlPath(LPTSTR lpszUrl, DWORD dwSize);
static void loadURL(BSTR urlBStr);

static const int dragBarHeight = 30;
#define MAX_URL_LENGTH  1024
static wchar_t strPtr[MAX_URL_LENGTH];
static int strLen;

static void clearHeap() {
	int i = 0;
	while (i < cntTestSite) {
		if (urlTestSite[i]) {
			HeapFree(GetProcessHeap(), 0, urlTestSite[i]);
			urlTestSite[i] = NULL;
		}
		i++;
	}
}

static bool usesLayeredWebView()
{
    return s_usesLayeredWebView;
}

static bool shouldUseFullDesktop()
{
    return s_fullDesktop;
}

class SimpleEventListener : public DOMEventListener {
public:
    SimpleEventListener(LPWSTR type)
    {
        wcsncpy_s(m_eventType, 100, type, 100);
        m_eventType[99] = 0;
    }

    virtual HRESULT STDMETHODCALLTYPE handleEvent(IDOMEvent* evt)
    {
        wchar_t message[255];
        wcscpy_s(message, 255, m_eventType);
        wcscat_s(message, 255, L" event fired!");
        ::MessageBox(0, message, L"Event Handler", MB_OK);
        return S_OK;
    }

private:
    wchar_t m_eventType[100];
};

HRESULT STDMETHODCALLTYPE WinLauncherWebResLoad::QueryInterface(REFIID riid, void** ppvObject)
{
    *ppvObject = 0;
    if (IsEqualGUID(riid, IID_IUnknown))
        *ppvObject = static_cast<IWebResourceLoadDelegate*>(this);
    else if (IsEqualGUID(riid, IID_IWebResourceLoadDelegate))
        *ppvObject = static_cast<IWebResourceLoadDelegate*>(this);
    else
        return E_NOINTERFACE;

    AddRef();
    return S_OK;
}

ULONG STDMETHODCALLTYPE WinLauncherWebResLoad::AddRef(void)
{
    return ++m_refCount;
}

ULONG STDMETHODCALLTYPE WinLauncherWebResLoad::Release(void)
{
    ULONG newRef = --m_refCount;
    if (!newRef)
        delete(this);

    return newRef;
}

HRESULT WinLauncherWebResLoad::didFinishLoadingFromDataSource(IWebView* webView, unsigned long identifier, IWebDataSource* dataSource)
{
    IWebMutableURLRequest* request = 0;
    BSTR reqURL = 0;

    HRESULT hr = S_OK;
    hr = dataSource->request(&request);

    hr = request->URL(&reqURL);

	WLDEBUGMSG(L"identifier = 0x%x, reqURL = %s\n",  identifier, (TCHAR*)reqURL);
	if (reqURL) SysFreeString(reqURL);
	if (request) request->Release();
	return S_OK;
}

HRESULT WinLauncherWebResLoad::willSendRequest(IWebView* webView, unsigned long identifier, IWebURLRequest* request, IWebURLResponse* redirectResponse, IWebDataSource* dataSource, IWebURLRequest** newRequest)
{
	BSTR bstr1 = 0;
	request->URL(&bstr1);
	WLDEBUGMSG(L"start request url = %s\n", (TCHAR*)bstr1);
	TCHAR* pos = wcsstr((TCHAR*)bstr1, L".swf");
	if (pos != NULL) {
		haveSWFWebView = webView;
	}
#if 0
	if (redirectResponse) {
		BSTR bstr2 = 0;
		redirectResponse->URL(&bstr2);
		WLDEBUGMSG(L"start redirect url = %s\n", (TCHAR*)bstr2);
		if (_wcsnicmp((TCHAR*)bstr1, L"http:", 5) == 0 && _wcsnicmp((TCHAR*)bstr2, L"https", 5) == 0) {
			WLDEBUGMSG(L"**** redirect https -> http !!! ****\n");
		}
		if (bstr2) SysFreeString(bstr2);
	}
#endif
	if (bstr1) SysFreeString(bstr1);
	request->QueryInterface(newRequest);
	return S_OK;
}

HRESULT STDMETHODCALLTYPE WinLauncherWebPolicy::QueryInterface(REFIID riid, void** ppvObject)
{
    *ppvObject = 0;
    if (IsEqualGUID(riid, IID_IUnknown))
        *ppvObject = static_cast<IWebPolicyDelegate*>(this);
    else if (IsEqualGUID(riid, IID_IWebPolicyDelegate))
        *ppvObject = static_cast<IWebPolicyDelegate*>(this);
    else
        return E_NOINTERFACE;

    AddRef();
    return S_OK;
}

ULONG STDMETHODCALLTYPE WinLauncherWebPolicy::AddRef(void)
{
    return ++m_refCount;
}

ULONG STDMETHODCALLTYPE WinLauncherWebPolicy::Release(void)
{
    ULONG newRef = --m_refCount;
    if (!newRef)
        delete(this);

    return newRef;
}

HRESULT STDMETHODCALLTYPE WinLauncherWebPolicy::decidePolicyForNavigationAction(
		/* [in] */ IWebView* webView,
		/* [in] */ IPropertyBag* actionInformation,
		/* [in] */ IWebURLRequest* request,
		/* [in] */ IWebFrame* frame,
		/* [in] */ IWebPolicyDecisionListener* listener)
{
	BSTR bstr1 = 0;
	request->URL(&bstr1);
	WLDEBUGMSG(L"start request url = %s, frame = 0x%x\n", (TCHAR*)bstr1, frame);
	if (wcslen(szUrlPatternSpecial1) > 0 && wcsstr((TCHAR*)bstr1, szUrlPatternSpecial1) != NULL) {
		WLDEBUGMSG(L"UserAgent = %s\n", (TCHAR*)bstUserAgentSpecial1);
		gWebView->setCustomUserAgent(bstUserAgentSpecial1);
	} else {
		WLDEBUGMSG(L"UserAgent = %s\n", (TCHAR*)bstUserAgent);
		gWebView->setCustomUserAgent(bstUserAgent);
	}
	listener->use();
	if (bstr1) SysFreeString(bstr1);
	return S_OK;
}

HRESULT STDMETHODCALLTYPE WinLauncherWebPolicy::decidePolicyForMIMEType(
		/* [in] */ IWebView* webView,
		/* [in] */ BSTR type,
		/* [in] */ IWebURLRequest* request,
		/* [in] */ IWebFrame* frame,
		/* [in] */ IWebPolicyDecisionListener* listener)
{
	WLDEBUGMSG(L"start\n");
	listener->use();
	return S_OK;
}

static void initializeIniValue(HINSTANCE hInstance) {
	TCHAR tmpUserAgent[255];
	TCHAR modulePath[MAX_PATH];
	::GetModuleFileNameW(hInstance, modulePath, MAX_PATH);
	TCHAR* p = wcsrchr(modulePath, L'\\');
	*(p + 1) = 0;
	TCHAR dir[MAX_PATH];
	wcscpy(dir, modulePath);
	wcscat(dir, L"WinLauncher.ini");
	iCaptureEnable = GetPrivateProfileIntW(L"mode", L"Capture", 0, dir);
	iLoadWaitTime = GetPrivateProfileIntW(L"http", L"LoadWaitTime", 5000, dir);
	GetPrivateProfileStringW(L"http", L"UserAgentDefault", USER_AGENT_DEFAULT, tmpUserAgent, 255, dir);
	bstUserAgent = SysAllocString(tmpUserAgent);
	GetPrivateProfileStringW(L"http", L"UrlPatternSpecial1", L"", szUrlPatternSpecial1, 255, dir);
	GetPrivateProfileStringW(L"http", L"UserAgentSpecial1", USER_AGENT_DEFAULT, tmpUserAgent, 255, dir);
	bstUserAgentSpecial1 = SysAllocString(tmpUserAgent);
	TCHAR key[8] = {0};
	int i;
	for (i = 0; i < 255; i++) {
		_stprintf_s(key, 7, L"Site%d", (i + 1));
		//WLDEBUGMSG(L"key = %s\n", key);
		DWORD iLen = GetPrivateProfileStringW(L"http", key, L"", tmpUserAgent, 255, dir);
		if (iLen) {
			urlTestSite[i] = (TCHAR*)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (iLen + 1) * 2);
			wcscpy(urlTestSite[i], tmpUserAgent);
		} else {
			cntTestSite = i;
			break;
		}
	}
	posTestSite = -1;

}


//HRESULT WinLauncherWebResLoad::willSendRequest(IWebView* webView, unsigned long identifier, IWebURLRequest* request, IWebURLResponse* redirectResponse, IWebDataSource* dataSource, IWebURLRequest** newRequest)
//{
//	BSTR bstr1 = SysAllocStringLen(NULL, 2048);
//}

static HRESULT checkErrorCode(int iErrPoint, int iErrCode) {
	WLDEBUGMSG(L"start iErrCode = %d\n", iErrCode);
	if ((iErrCode <= -996 && iErrCode >= -999) || iErrCode == 5 || iErrCode == 102 || iErrCode == 122 || iErrCode == 0) {
		// ł郌x̃G[
		// -999 : dcancelNƁAResourceLoader.cppL.379G[ʒm
		//    8 : WinInetINTERNET_STATUS_REQUEST_COMPLETER[obNpAsyncRes->dwErrorɂ8(̃R}hŝɏ\ȋL悪܂)X
		//        (8  2013/05/23 ResourceHandleWin.cpp ɂďCΉς)
		//    5 : file://ł̃tH_ReadFileExŃG[
		//  102 : Frame load interrupted(by Localizable.strings)
		//  122 : Font Error
		WLDEBUGMSG(L"code, %d is just warn.\n", iErrCode);
		return S_OK;
	}
	WLDEBUGMSG(L"start code = %d\n", iErrCode);
	if (iErrCode == ERROR_INTERNET_TIMEOUT					/* 12002 */
	||  iErrCode == ERROR_INTERNET_INTERNAL_ERROR			/* 12004 */
	||	iErrCode == ERROR_INTERNET_INCORRECT_HANDLE_STATE	/* 12019 */
	||	iErrCode == ERROR_INTERNET_CONNECTION_ABORTED		/* 12030 */
	||	iErrCode == ERROR_INTERNET_CONNECTION_RESET			/* 12031 */
	||	iErrCode == ERROR_INTERNET_SEC_CERT_CN_INVALID		/* 12038 */
	||  iErrCode == ERROR_INTERNET_INVALID_CA		        /* 12045 */
	||	iErrCode == ERROR_INTERNET_FORTEZZA_LOGIN_NEEDED	/* 12054 */
	||  iErrCode == ERROR_INTERNET_SEC_CERT_REV_FAILED      /* 12057 */
	||  iErrCode == ERROR_HTTP_INVALID_SERVER_RESPONSE		/* 12152 */
	||	iErrCode == ERROR_HTTP_REDIRECT_FAILED			    /* 12156 */
	||	iErrCode == ERROR_INTERNET_SECURITY_CHANNEL_ERROR	/* 12157 */
	||	iErrCode == ERROR_INTERNET_SEC_CERT_DATE_INVALID	/* 12037 https://localhost̎̓IIؖȂ̂Ŗ{G[͖ */
	|| (iErrPoint == ERR_RESOURCE_LOAD && iErrCode == ERROR_INTERNET_NAME_NOT_RESOLVED)		/* 12007 */
	|| ((iErrPoint == ERR_RESOURCE_LOAD || ERR_FRAME_PROV_LOAD) && iErrCode == ERROR_INTERNET_CANNOT_CONNECT)		/* 12029 cant reach Server (ResourceLoadDelegatȅꍇ̂ݖ) */
	) {
		WLDEBUGMSG(L"code, %d is just warn.\n", iErrCode);
		return S_OK;
	}
	return S_FALSE;
}

HRESULT WinLauncherWebResLoad::didFailLoadingWithError(IWebView* webView, unsigned long identifier, IWebError* error, IWebDataSource* dataSource)
{
	int iErrCode;
	if (error == NULL) return S_OK;
	error->code(&iErrCode);
	if (checkErrorCode(ERR_RESOURCE_LOAD, iErrCode) == S_OK) return S_OK;
	// never interrupt webkit procedure! any user interface can appear after PostMessage.
	if (hMainWnd) ::PostMessage(hMainWnd, WM_ERR_WININET, ERR_RESOURCE_LOAD, iErrCode);
	return S_OK;
}

HRESULT WinLauncherWebHost::updateAddressBar(IWebView* webView)
{
    IWebFrame* mainFrame = 0;
    IWebDataSource* dataSource = 0;
    IWebMutableURLRequest* request = 0;
    BSTR frameURL = 0;

    HRESULT hr = S_OK;

    hr = webView->mainFrame(&mainFrame);
    if (FAILED(hr))
        goto exit;

    hr = mainFrame->dataSource(&dataSource);
    if (FAILED(hr) || !dataSource)
        hr = mainFrame->provisionalDataSource(&dataSource);
    if (FAILED(hr) || !dataSource)
        goto exit;

    hr = dataSource->request(&request);
    if (FAILED(hr) || !request)
        goto exit;

    hr = request->mainDocumentURL(&frameURL);
    if (FAILED(hr))
        goto exit;

	WLDEBUGMSG(L"frameURL = %s\n",  (TCHAR*)frameURL);
    SendMessage(hURLBarWnd, (UINT)WM_SETTEXT, 0, (LPARAM)frameURL);

exit:
    if (mainFrame)
        mainFrame->Release();
    if (dataSource)
        dataSource->Release();
    if (request)
        request->Release();
    if (frameURL) SysFreeString(frameURL);
    return 0;
}

HRESULT STDMETHODCALLTYPE WinLauncherWebHost::QueryInterface(REFIID riid, void** ppvObject)
{
    *ppvObject = 0;
    if (IsEqualGUID(riid, IID_IUnknown))
        *ppvObject = static_cast<IWebFrameLoadDelegate*>(this);
    else if (IsEqualGUID(riid, IID_IWebFrameLoadDelegate))
        *ppvObject = static_cast<IWebFrameLoadDelegate*>(this);
    else
        return E_NOINTERFACE;

    AddRef();
    return S_OK;
}

ULONG STDMETHODCALLTYPE WinLauncherWebHost::AddRef(void)
{
    return ++m_refCount;
}

ULONG STDMETHODCALLTYPE WinLauncherWebHost::Release(void)
{
    ULONG newRef = --m_refCount;
    if (!newRef)
        delete(this);

    return newRef;
}

HRESULT WinLauncherWebHost::didFinishDocumentLoadForFrame(IWebView* webView, IWebFrame* frame)
{
	WLDEBUGMSG(L"start\n");
		return S_OK;
	}

// ȉdefineLɂƃ[NN̂ŒӁII
// #define YOUTUBE_FLASH_TRANSPARENT 1

HRESULT WinLauncherWebHost::didFinishLoadForFrame(IWebView* webView, IWebFrame* frame)
{
    HRESULT hr = S_OK;
#ifdef YOUTUBE_FLASH_TRANSPARENT
    IWebDataSource* dataSource = 0;
    IWebMutableURLRequest* request = 0;
    BSTR frameURL = 0;
    IDOMDocument* doc = 0;
	IDOMHTMLDocument* idoc = 0;
    IDOMElement* element = 0;
    IDOMEventTarget* target = 0;
	BSTR docUrl = 0;

    hr = frame->dataSource(&dataSource);
    if (FAILED(hr) || !dataSource)
        hr = frame->provisionalDataSource(&dataSource);
    if (FAILED(hr) || !dataSource)
        goto exit;

    hr = dataSource->request(&request);
    if (FAILED(hr) || !request)
        goto exit;

    hr = request->mainDocumentURL(&frameURL);
    if (FAILED(hr))
        goto exit;
	WLDEBUGMSG(L"frameURL = %s\n",  (TCHAR*)frameURL);

    frame->DOMDocument(&doc);
    hr = doc->QueryInterface(IID_IDOMHTMLDocument, reinterpret_cast<void**>(&idoc));
	if (!SUCCEEDED(hr))
        goto exit;

    hr = idoc->URL(&docUrl);
    if (!SUCCEEDED(hr))
        goto exit;
	WLDEBUGMSG(L"docUrl = %s\n",  (TCHAR*)docUrl);
	TCHAR* pos = wcsstr((TCHAR*)docUrl, L"about:blank");

	if (haveSWFWebView && pos) {
		pos = wcsstr((TCHAR*)frameURL, L"www.youtube.com");
		if (pos != NULL) {
			WLDEBUGMSG(L"set transparent to wmode\n");
			TCHAR mbuf[] = L"javascript: for (var ems = document.embeds, i = 0, em; em = ems[i]; i++) { em.setAttribute('wmode', 'transparent'); var nx = em.nextSibling, pn = em.parentNode; pn.removeChild(em); pn.insertBefore(em, nx); } ";
			BSTR testJs = SysAllocString(mbuf);
			BSTR testResult;
			webView->stringByEvaluatingJavaScriptFromString(testJs, &testResult);
			SysFreeString(testResult);
			SysFreeString(testJs);
		}
	}

	haveSWFWebView = 0;
    hr = doc->getElementById(L"webkit logo", &element);
    if (!SUCCEEDED(hr))
        goto exit;

    hr = element->QueryInterface(IID_IDOMEventTarget, reinterpret_cast<void**>(&target));
    if (!SUCCEEDED(hr))
        goto exit;

	// SimpleEventListener  delete Ȃ߁A[NƂȂI
    hr = target->addEventListener(L"click", new SimpleEventListener (L"webkit logo click"), FALSE);
    if (!SUCCEEDED(hr))
        goto exit;

exit:
    if (docUrl) SysFreeString(docUrl);
    if (frameURL) SysFreeString(frameURL);
#endif

	if (iYahooMode == 2) {
		iYahooCounter++;
		g_nIDEvent = SetTimer(hMainWnd, TIMER_ID2, YAHOO_INTERVAL, NULL);
		if ((iYahooCounter % YAHOO_LOG_INTERVAL) == 0) WLDEBUGMSG(L"Success iYahooCounter = %d\n",  iYahooCounter);
	} else if (iYahooMode == 3) {
		if (posTestSite != -1) {
			if (g_nIDEvent) KillTimer(hMainWnd, TIMER_ID4);
			WLDEBUGMSG(L"AutoCapture progress\n");
			iFinishLoadForFrame = 1;
			g_nIDEvent = SetTimer(hMainWnd, TIMER_ID4, iLoadWaitTime, NULL);	// google map͕\I܂łdidFinishLoadForFrame
		}
	} else if (iYahooMode == 1) {
		iYahooCounter++;
		BSTR testUrl = SysAllocString(g_szLocalTestUrl);
		loadURL(testUrl);
		SysFreeString(testUrl);
		if ((iYahooCounter % YAHOO_LOG_INTERVAL) == 0) WLDEBUGMSG(L"Success iYahooCounter = %d\n",  iYahooCounter);
	}
#ifdef YOUTUBE_FLASH_TRANSPARENT
    if (target)
        target->Release();
    if (element)
        element->Release();
    if (doc)
        doc->Release();
    if (idoc)
        idoc->Release();
    if (dataSource)
        dataSource->Release();
    if (request)
        request->Release();
#endif
   return hr;
}

HRESULT WinLauncherWebHost::didFailLoadWithError(IWebView* webView, IWebError *error, IWebFrame* forFrame)
{
	if (iYahooMode == 2) {
		iYahooCounter++;
		WLDEBUGMSG(L"Error Happen iYahooCounter = %d\n",  iYahooCounter);
		g_nIDEvent = SetTimer(hMainWnd, TIMER_ID2, 1000, NULL);
	} else if (iYahooMode == 3) {
		if (posTestSite == -1) return S_OK;
		if (g_nIDEvent) KillTimer(hMainWnd, TIMER_ID4);
		int iErrCode;
		if (error == NULL) return S_OK;
		error->code(&iErrCode);
		if (checkErrorCode(ERR_FRAME_LOAD, iErrCode) == S_OK) return S_OK;
		MYDEBUGMSG(L"Error Happen AutoCapture iErrCode = %d\n");
		iFinishLoadForFrame = 1;
		g_nIDEvent = SetTimer(hMainWnd, TIMER_ID4, iLoadWaitTime, NULL);
	} else if (iYahooMode == 1) {
		iYahooCounter++;
		WLDEBUGMSG(L"Error Happen iYahooCounter = %d\n",  iYahooCounter);
		BSTR testUrl = SysAllocString(g_szLocalTestUrl);
		loadURL(testUrl);
		SysFreeString(testUrl);
	} else {
		int iErrCode;
		if (error == NULL) return S_OK;
		error->code(&iErrCode);
		if (checkErrorCode(ERR_FRAME_LOAD, iErrCode) == S_OK) return S_OK;
		// never interrupt webkit procedure! any user interface can appear after PostMessage.
		if (hMainWnd) ::PostMessage(hMainWnd, WM_ERR_WININET, ERR_FRAME_LOAD, iErrCode);
	}
	return S_OK;
}

HRESULT WinLauncherWebHost::didFailProvisionalLoadWithError(IWebView* webView, IWebError *error, IWebFrame* forFrame)
{
	HRESULT hr;
    BSTR errorDescription = 0;
	int iErrCode;
	error->code(&iErrCode);
	if (checkErrorCode(ERR_FRAME_PROV_LOAD, iErrCode) == S_OK) return S_OK;
	
    hr = error->localizedDescription(&errorDescription);
    if (FAILED(hr))
        errorDescription = L"Failed to load page and to localize error description.";
	WLDEBUGMSG(L"iErrCode = %d, ErrorDescription = %s\n", iErrCode, static_cast<LPCWSTR>(errorDescription));
    if (SUCCEEDED(hr))
        SysFreeString(errorDescription);

	// never interrupt webkit procedure! any user interface can appear after PostMessage.
	if (hMainWnd) ::PostMessage(hMainWnd, WM_ERR_WININET, ERR_FRAME_PROV_LOAD, iErrCode);
	return S_OK;
}


static void resizeSubViews()
{
    if (usesLayeredWebView() || !gViewWindow)
        return;

    RECT rcClient;
    GetClientRect(hMainWnd, &rcClient);
    MoveWindow(hURLBarWnd, 0, 0, rcClient.right, URLBAR_HEIGHT, TRUE);
    MoveWindow(gViewWindow, 0, URLBAR_HEIGHT, rcClient.right, rcClient.bottom - URLBAR_HEIGHT, TRUE);
}

static void subclassForLayeredWindow()
{
    hMainWnd = gViewWindow;
#if defined _M_AMD64 || defined _WIN64
    DefWebKitProc = reinterpret_cast<WNDPROC>(::GetWindowLongPtr(hMainWnd, GWLP_WNDPROC));
    ::SetWindowLongPtr(hMainWnd, GWLP_WNDPROC, reinterpret_cast<LONG_PTR>(WndProc));
#else
    DefWebKitProc = reinterpret_cast<WNDPROC>(::GetWindowLong(hMainWnd, GWL_WNDPROC));
    ::SetWindowLong(hMainWnd, GWL_WNDPROC, reinterpret_cast<LONG_PTR>(WndProc));
#endif
}

static void computeFullDesktopFrame()
{
    RECT desktop;
    if (!::SystemParametersInfo(SPI_GETWORKAREA, 0, static_cast<void*>(&desktop), 0))
        return;

    s_windowPosition.x = 0;
    s_windowPosition.y = 0;
    s_windowSize.cx = desktop.right - desktop.left;
    s_windowSize.cy = desktop.bottom - desktop.top;
}

BOOL WINAPI DllMain(HINSTANCE dllInstance, DWORD reason, LPVOID)
{
    if (reason == DLL_PROCESS_ATTACH)
        hInst = dllInstance;

    return TRUE;
}
// <img id=\"webkit logo\" src=\"http://webkit.org/images/icon-gold.png\" alt=\"Face\">
static bool LoadHtmlInitString() {
    IWebFrame* frame;
	BSTR bstr = NULL;
	int iClassCount = 0;
	TCHAR* tcpClasses = L"no class";
    HRESULT hr = gWebView->mainFrame(&frame);
    if (FAILED(hr)) return FALSE;

	IWebKitStatistics* tmpWebKitStatistics = 0;
	if (FAILED(WebKitCreateInstance(CLSID_WebKitStatistics, 0, IID_IWebKitStatistics, reinterpret_cast<void**>(&tmpWebKitStatistics)))) {
		MYDEBUGMSG(L"Failed create IWebKitStatistics!\n");
	}
	if (FAILED(tmpWebKitStatistics->comClassCount(&iClassCount))) {
		MYDEBUGMSG(L"Failed comClassNameCounts!\n");
	}
	if (iClassCount > 0) {
		bstr = SysAllocStringLen(NULL, 8192);
		if (FAILED(tmpWebKitStatistics->comClassNameCounts(&bstr))) {
			MYDEBUGMSG(L"Failed comClassNameCounts!\n");
		}
		tcpClasses = (TCHAR*)bstr;
	}
    TCHAR* fmt = NULL;
	fmt = (TCHAR*)malloc(10240);
    _stprintf_s(fmt, 10240, TEXT("<p style=\"background-color: #00FF00\">Testing</p><br>No Image Version<br><div style=\"border: solid blue; background: white;\" contenteditable=\"true\">div with blue border</div><ul><li>foo<li>bar<li>baz</ul><br><a href=\"http://cgi.mediamix.ne.jp/~k2896/url/mm.cgi?l+1+0+necst1\">BookMarks</a><br><a href=\"http://www.google.co.jp\">http://www.google.co.jp</a><br><a href=\"http://www.geocities.jp/shuijiaohenduo/garden/default.htm\">http://www.geocities.jp/shuijiaohenduo/garden/default.htm</a><br><a href=\"http://localhost/\">http://localhost/</a><br><a href=\"%s\">ikkyu</a><br><a href=\"http://www.post.japanpost.jp/index.html\">http://www.post.japanpost.jp/index.html</a><br><a href=\"file:///C:/WINDOWS/Help/migwiz.htm\">file:///C:/WINDOWS/Help/migwiz.htm</a><br><a href=\"file:///C:/WINDOWS/links.htm\">file:///C:/WINDOWS/links.htm</a><br><a href=\"http://jquerymobile.com/demos/1.1.1/docs/forms/docs-forms.html\">http://jquerymobile.com/demos/1.1.1/docs/forms/docs-forms.html</a><br><a href=\"http://www.yahoo.co.jp\">http://www.yahoo.co.jp</a><br>current classes<br><pre>%s</pre>"), L"http://ajaxsearch.partners.agoda.jp/asia/south_korea/seoul/pj_hotel.html?asq=gFH8gcqAcjR%2bwXCOf14iyw%3d%3d", 
	tcpClasses);

	BSTR defaultHTML = SysAllocString(fmt);
	frame->loadHTMLString(defaultHTML, 0);
    frame->Release();
	SysFreeString(defaultHTML);
	if (bstr) SysFreeString(bstr);
	if (fmt) free(fmt);
	if (tmpWebKitStatistics) tmpWebKitStatistics->Release();
	return TRUE;
}

extern "C" __declspec(dllexport) int WINAPI dllLauncherEntryPoint(HINSTANCE, HINSTANCE, LPTSTR, int nCmdShow)
{
#ifdef _CRTDBG_MAP_ALLOC
    _CrtSetReportFile(_CRT_WARN, _CRTDBG_FILE_STDERR);
    _CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_FILE);
#endif

     // TODO: Place code here.
    MSG msg = {0};
    HACCEL hAccelTable;

    INITCOMMONCONTROLSEX InitCtrlEx;

    InitCtrlEx.dwSize = sizeof(INITCOMMONCONTROLSEX);
    InitCtrlEx.dwICC  = 0x00004000; //ICC_STANDARD_CLASSES;
    InitCommonControlsEx(&InitCtrlEx);

	// read ini file

    int argc = 0;
    WCHAR** argv = CommandLineToArgvW(GetCommandLineW(), &argc);
    for (int i = 1; i < argc; ++i) {
        if (!wcsicmp(argv[i], L"--transparent"))
            s_usesLayeredWebView = true;
        else if (!wcsicmp(argv[i], L"--desktop"))
            s_fullDesktop = true;
		else if (!_wcsnicmp(argv[i], L"http", 4) || !_wcsnicmp(argv[i], L"file", 4)) {
			wcscpy(strPtr, argv[i]);
			strLen = wcslen(strPtr);
		}
    }

    // Initialize global strings
    LoadString(hInst, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
    LoadString(hInst, IDC_WINLAUNCHER, szWindowClass, MAX_LOADSTRING);
    MyRegisterClass(hInst);
	initializeIniValue(hInst);

	// Get Test URL
	GetBaseUrlPath(g_szLocalTestUrl, MAX_PATH);

    if (shouldUseFullDesktop())
        computeFullDesktopFrame();

    // Init COM
    OleInitialize(NULL);

//	hMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDC_WINLAUNCHER));
    if (usesLayeredWebView()) {
        hURLBarWnd = CreateWindow(L"EDIT", L"Type URL Here",
                    WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_BORDER | ES_LEFT | ES_AUTOVSCROLL, 
                    s_windowPosition.x, s_windowPosition.y + s_windowSize.cy, s_windowSize.cx, URLBAR_HEIGHT,
                    0,
                    0,
                    hInst, 0);
    } else {
        hMainWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
                       0, 0, 800, 600, 0, 0, hInst, 0);
//                       CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 0, 0, hInst, 0);

        if (!hMainWnd)
            return FALSE;
		// for Rabbit
		//{
		//	const DWORD_PTR dwHwndTabletProperty = 
		//	TABLET_DISABLE_PRESSANDHOLD | // disables press and hold (right-click) gesture
		//	TABLET_DISABLE_PENTAPFEEDBACK | // disables UI feedback on pen up (waves)
		//	TABLET_DISABLE_PENBARRELFEEDBACK | // disables UI feedback on pen button down (circle)
		//	TABLET_DISABLE_FLICKS; // disables pen flicks (back, forward, drag down, drag up)
		//	HRESULT hsts = 0;
		//	OUT_HR(hsts = ::SetProp(hMainWnd, MICROSOFT_TABLETPENSERVICE_PROPERTY, reinterpret_cast<HANDLE>(dwHwndTabletProperty)));
		//	MYDEBUGMSG(L"SetProp sts = %d\n", hsts);
		//}

        hURLBarWnd = CreateWindow(L"EDIT", 0,
                    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT | ES_AUTOVSCROLL, 
                    0, 0, 0, 0,
                    hMainWnd,
                    0,
                    hInst, 0);

        ShowWindow(hMainWnd, nCmdShow);
        UpdateWindow(hMainWnd);
    }
#if defined _M_AMD64 || defined _WIN64
    DefEditProc = reinterpret_cast<WNDPROC>(GetWindowLongPtr(hURLBarWnd, GWLP_WNDPROC));
    SetWindowLongPtr(hURLBarWnd, GWLP_WNDPROC, reinterpret_cast<LONG_PTR>(MyEditProc));
#else
    DefEditProc = reinterpret_cast<WNDPROC>(GetWindowLong(hURLBarWnd, GWL_WNDPROC));
    SetWindowLong(hURLBarWnd, GWL_WNDPROC, reinterpret_cast<LONG_PTR>(MyEditProc));
#endif

    SetFocus(hURLBarWnd);

    RECT clientRect = { s_windowPosition.x, s_windowPosition.y, s_windowPosition.x + s_windowSize.cx, s_windowPosition.y + s_windowSize.cy };

    HRESULT hr = WebKitCreateInstance(CLSID_WebCache, 0, IID_IWebCache, reinterpret_cast<void**>(&gWebCache));
    if (FAILED(hr))
        goto exit;
#ifdef WLCACHE
    gWebCache->setDisabled(FALSE);
#else
    gWebCache->setDisabled(TRUE);
#endif
	BOOL bWcc;
    gWebCache->disabled(&bWcc);
	MYDEBUGMSG(L"gWebCache disabled = %d\n", bWcc);	// default 0, change to 1 (for avoiding memory leak)

	IWebPreferences* tmpPreferences = 0;
//    IWebPreferences* standardPreferences = 0;
    if (FAILED(WebKitCreateInstance(CLSID_WebPreferences, 0, IID_IWebPreferences, reinterpret_cast<void**>(&tmpPreferences))))
        goto exit;

    if (FAILED(tmpPreferences->standardPreferences(&standardPreferences)))
        goto exit;

	// The default value of a preference defined at "WebPreferences.cpp"
	// And preferences are stored at Application Data\Apple Computer\Preferences\WinLauncher.exe.plist
	BOOL bAsv;
    standardPreferences->autosaves(&bAsv);
	MYDEBUGMSG(L"autosaves = %d\n", bAsv);	// default 1, keep

    standardPreferences->setZoomsTextOnly(FALSE);

//    standardPreferences->setAcceleratedCompositingEnabled(TRUE);
	BOOL bAcc;
    standardPreferences->acceleratedCompositingEnabled(&bAcc);
	MYDEBUGMSG(L"AcceleratedCompositingEnabled = %d\n", bAcc);	// default 0, keep

//    standardPreferences->setCacheModel(WebCacheModelDocumentViewer);		// 0
//    standardPreferences->setCacheModel(WebCacheModelDocumentBrowser);		// 1
    standardPreferences->setCacheModel(WebCacheModelPrimaryWebBrowser);	// 2
	WebCacheModel iCmdl;
	standardPreferences->cacheModel(&iCmdl);
	MYDEBUGMSG(L"cacheModel = %d\n", iCmdl);

//#ifdef WLCACHE
//    standardPreferences->setUsesPageCache(TRUE);
//#else
    standardPreferences->setUsesPageCache(FALSE);
//#endif
	BOOL bUpc;
    standardPreferences->usesPageCache(&bUpc);
	MYDEBUGMSG(L"usesPageCache = %d\n", bUpc);	// default 1, keep
    standardPreferences->setPrivateBrowsingEnabled(FALSE);	// OfflineWebApplicationCache requires setPrivateBrowsingEnabled(FALSE) 
	BOOL bPrb;
    standardPreferences->privateBrowsingEnabled(&bPrb);
	MYDEBUGMSG(L"privateBrowsingEnabled = %d\n", bPrb);	// default 0, keep

	BOOL bPlg;
    standardPreferences->arePlugInsEnabled(&bPlg);
	MYDEBUGMSG(L"arePlugInsEnabled = %d\n", bPlg);	// default 1, keep

	IWebPreferencesPrivate* tmpPreferencesPrivate = 0;
    hr = standardPreferences->QueryInterface(IID_IWebPreferencesPrivate, reinterpret_cast<void**>(&tmpPreferencesPrivate));
    if (FAILED(hr))
        goto exit;

	//tmpPreferencesPrivate->setDatabasesEnabled(TRUE);
	BOOL bDbe;
    tmpPreferencesPrivate->databasesEnabled(&bDbe);
	MYDEBUGMSG(L"databasesEnabled = %d\n", bDbe);	// default 1, keep

	tmpPreferencesPrivate->setLocalStorageEnabled(TRUE);
	BOOL bLse;
    tmpPreferencesPrivate->localStorageEnabled(&bLse);
	MYDEBUGMSG(L"localStorageEnabled = %d\n", bLse);	// default 1, keep
	// file name is fixed at domain name + ".localstorage"
	// You can set folder name to "DatabasePath"

	TCHAR ldbpath[MAX_PATH];
	if (SHGetSpecialFolderPath(NULL, ldbpath, CSIDL_LOCAL_APPDATA, TRUE)) {
	    // "C:\Documents and Settings\username\Local Settings\Application Data"擾
		wcscat(ldbpath, L"\\Apple Computer\\WebKit"); 
	} else {
	    // fBNg擾siʏ킠肦Ȃj
		wcscpy(ldbpath, L"C:\\Windows\\sdelocalstorage");
	}
	BSTR bstLDBPath = SysAllocString(ldbpath);
	tmpPreferencesPrivate->setLocalStorageDatabasePath(bstLDBPath);
	SysFreeString(bstLDBPath);

	TCHAR stdfont[] = L"Times New Roman";
	BSTR bstStdFont = SysAllocString(stdfont);
	standardPreferences->setStandardFontFamily(bstStdFont);
	SysFreeString(bstStdFont);
	standardPreferences->setDefaultFontSize(16);

	BSTR bstr = SysAllocStringLen(NULL,256);
	tmpPreferencesPrivate->localStorageDatabasePath(&bstr);
	MYDEBUGMSG(L"localStorageDatabasePath = %s\n", (TCHAR*)bstr);	// default "", change to 
	SysFreeString(bstr);

	TCHAR defencoding[] = L"shift_jis";
//	TCHAR defencoding[] = L"utf-8";
	bstr = SysAllocString(defencoding);
	standardPreferences->setDefaultTextEncodingName(bstr);		// defautl "ISO-8859-1", change to "shift_jis"
	SysFreeString(bstr);

	bstr = SysAllocStringLen(NULL,256);
	standardPreferences->defaultTextEncodingName(&bstr);
	MYDEBUGMSG(L"defaultTextEncodingName = %s\n", (TCHAR*)bstr);
	SysFreeString(bstr);

	tmpPreferencesPrivate->setAllowUniversalAccessFromFileURLs(TRUE);
	BOOL bAua;
    tmpPreferencesPrivate->allowUniversalAccessFromFileURLs(&bAua);
	MYDEBUGMSG(L"allowUniversalAccessFromFileURLs = %d\n", bAua);	// default 0, change to 1

	BOOL bAff;
    tmpPreferencesPrivate->allowFileAccessFromFileURLs(&bAff);
	MYDEBUGMSG(L"allowFileAccessFromFileURLs = %d\n", bAff);	// default 1, keep

// ȉ̍s̓NXhCʐMŗLɂꍇ̂ݗLB
// NXhCʐM̗L̓ZLeB̊ϓ_Aʏ̓T[o̐ݒ(Access-Control-Allow-Origin)ōsB
// C:\Documents and Settings\[User Name]\Application Data\Apple Computer\Preferences\WinLauncher.exe.plistłON/OFF\B
	tmpPreferencesPrivate->setWebSecurityEnabled(FALSE);
	BOOL bWsc;
    tmpPreferencesPrivate->isWebSecurityEnabled(&bWsc);
	MYDEBUGMSG(L"isWebSecurityEnabled = %d\n", bWsc);	// default 1, change to 0

// ȉ̍s̓[X͗LBeXgplistON/OFF
	tmpPreferencesPrivate->setOfflineWebApplicationCacheEnabled(TRUE);
	BOOL bOac;
    tmpPreferencesPrivate->offlineWebApplicationCacheEnabled(&bOac);
	MYDEBUGMSG(L"offlineWebApplicationCacheEnabled = %d\n", bOac);	// default 0, change to 1

	tmpPreferencesPrivate->setDeveloperExtrasEnabled(TRUE);
	BOOL bDee;
    tmpPreferencesPrivate->developerExtrasEnabled(&bDee);
	MYDEBUGMSG(L"developerExtrasEnabled = %d\n", bDee);	// default 0, change to 1

    hr = WebKitCreateInstance(CLSID_WebView, 0, IID_IWebView, reinterpret_cast<void**>(&gWebView));
    if (FAILED(hr))
        goto exit;

    hr = gWebView->QueryInterface(IID_IWebViewPrivate, reinterpret_cast<void**>(&gWebViewPrivate));
    if (FAILED(hr))
        goto exit;

    hr = gWebView->QueryInterface(IID_IWebIBActions, reinterpret_cast<void**>(&gWebActions));
    if (FAILED(hr))
        goto exit;

	// DefaultUA : Mozilla/5.0 (Windows NT 5.1) AppleWebKit/534+ (KHTML, like Gecko)
	//BSTR bstUserAgent = SysAllocString(L"Mozilla/5.0 (Windows; U; Windows NT 5.1; ja-JP) AppleWebKit/533.18.1 (KHTML, like Gecko) Version/5.0 Safari/533.16");
	//BSTR bstUserAgent = SysAllocString(L"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.79 Safari/537.1");
	// Safari for Windows
//	BSTR bstUserAgent = SysAllocString(L"Mozilla/5.0 (Windows; U; Windows NT 6.1; en-us) AppleWebKit/534.52.7 (KHTML, like Gecko) Version/5.1 Safari/534.52.7");
//	BSTR bstUserAgent = SysAllocString(szUserAgent);

	// Play.net
	//BSTR bstUserAgent = SysAllocString(L"Mozilla/5.0 (Windows; U; Windows NT 6.2) AppleWebKit/537.17 (KHTML, like Gecko) Play.net/2.0 Safari/534.52.7 Chrome/11.0.696.65");
	hr = gWebView->setCustomUserAgent(bstUserAgent);
	//SysFreeString(bstUserAgent);
    if (FAILED(hr))
        goto exit;

	//BOOL bEdt    gWebView->isEditable(&bEdt);
	//MYDEBUGMSG(L"WebView isEditable = %d\n", bEdt);	// default 0, change to 1

    gWebHost = new WinLauncherWebHost();
    gWebHost->AddRef();
    hr = gWebView->setFrameLoadDelegate(gWebHost);
    if (FAILED(hr))
        goto exit;

	gWebresLoad = new WinLauncherWebResLoad();
    gWebresLoad->AddRef();
    hr = gWebView->setResourceLoadDelegate(gWebresLoad);
    if (FAILED(hr))
        goto exit;
	WLDEBUGMSG(L"Success setResourceLoadDelegate\n");

	gWebpolicy = new WinLauncherWebPolicy();
    gWebpolicy->AddRef();
    hr = gWebView->setPolicyDelegate(gWebpolicy);
    if (FAILED(hr))
        goto exit;
	WLDEBUGMSG(L"Success setPolicyDelegate\n");

	gPrintDelegate = new PrintWebUIDelegate;
    gPrintDelegate->AddRef();
    hr = gWebView->setUIDelegate(gPrintDelegate);
    if (FAILED (hr))
        goto exit;

    //gPrintDelegatePrivate2 = new PrintWebUIDelegatePrivate2;
    //gPrintDelegatePrivate2->AddRef();
    //hr = gWebView->setUIDelegate(gPrintDelegatePrivate2);
    //if (FAILED (hr))
    //    goto exit;

    hr = gWebView->setHostWindow(reinterpret_cast<OLE_HANDLE>(hMainWnd));
    if (FAILED(hr))
        goto exit;

    hr = gWebView->initWithFrame(clientRect, 0, 0);
    if (FAILED(hr))
        goto exit;

	// WebDatabaseManager̗p͕KinitWithFraměōsI
	{
		IWebDatabaseManager* databaseManager;
		IWebDatabaseManager* tmpDatabaseManager;
		if (FAILED(WebKitCreateInstance(CLSID_WebDatabaseManager, 0, IID_IWebDatabaseManager, (void**)&tmpDatabaseManager)))
			goto exit;
		if (FAILED(tmpDatabaseManager->sharedWebDatabaseManager(&databaseManager)))
	        goto exit;
		// LoginURL.txtɏꂽhCŐݒ肷B
		// WebSQLDatabase𗘗pꍇAȉ̃t@C\ߗpӂKvB
		// C:\Documents and Settings\[User]\Local Settings\Application Data\Apple Computer\WebKit\Databases\Databases.db
		databaseManager->setQuota(TEXT("file:///"), 1073741824);	// Max 1GB
		databaseManager->setQuota(TEXT("http://labo.vivo.name/"), 1073741824);	// Max 1GB
	}

	if (LoadHtmlInitString() == FALSE) goto exit;

    hr = gWebViewPrivate->inspector(&gWebInspector);
    if (FAILED(hr))
        goto exit;
    hr = gWebInspector->attach();
    if (FAILED(hr))
        goto exit;

    hr = gWebViewPrivate->setTransparent(usesLayeredWebView());
    if (FAILED(hr))
        goto exit;

    hr = gWebViewPrivate->setUsesLayeredWindow(usesLayeredWebView());
    if (FAILED(hr))
        goto exit;

	hr = gWebViewPrivate->viewWindow(reinterpret_cast<OLE_HANDLE*>(&gViewWindow));
    if (FAILED(hr) || !gViewWindow)
        goto exit;

    if (usesLayeredWebView())
        subclassForLayeredWindow();

    resizeSubViews();

    ShowWindow(gViewWindow, nCmdShow);
    UpdateWindow(gViewWindow);

    hAccelTable = LoadAccelerators(hInst, MAKEINTRESOURCE(IDC_WINLAUNCHER));

    // Main message loop:
    while (GetMessage(&msg, NULL, 0, 0)) {
        if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }

exit:
	if (gWebInspector) gWebInspector->close();
	if (gWebresLoad) gWebresLoad->Release();
	if (gWebHost) gWebHost->Release();
    if (gPrintDelegate) gPrintDelegate->Release();
    if (gWebViewPrivate) gWebViewPrivate->Release();
	if (gWebView) {
		// flashɃAvIƈȉapG[ɂȂ邽try catch
		try {
		gWebView->close();
	    gWebView->Release();
        } catch(...) {  // OLb`
		}
	}
    if (standardPreferences) standardPreferences->Release();
    if (tmpPreferences) tmpPreferences->Release();
	if (gWebCache) gWebCache->Release();

    shutDownWebKit();
#ifdef _CRTDBG_MAP_ALLOC
    _CrtDumpMemoryLeaks();
#endif
	clearHeap();
    // Shut down COM.
    OleUninitialize();
    
    return static_cast<int>(msg.wParam);
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
    WNDCLASSEX wcex;

    wcex.cbSize = sizeof(WNDCLASSEX);

    wcex.style          = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = WndProc;
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = hInstance;
    wcex.hIcon          = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WINLAUNCHER));
    wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground  = 0;
    wcex.lpszMenuName   = MAKEINTRESOURCE(IDC_WINLAUNCHER);
//    wcex.lpszMenuName   = NULL;
    wcex.lpszClassName  = szWindowClass;
    wcex.hIconSm        = LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

    return RegisterClassEx(&wcex);
}

static BOOL CALLBACK AbortProc(HDC hDC, int Error)
{
	WLDEBUGMSG(L"start\n");
    MSG msg;
    while (::PeekMessage(&msg, 0, 0, 0, PM_REMOVE)) {
        ::TranslateMessage(&msg);
        ::DispatchMessage(&msg);
    }

    return TRUE;
}

static HDC getPrinterDC()
{
	WLDEBUGMSG(L"start\n");
    PRINTDLG pdlg;
    memset(&pdlg, 0, sizeof(PRINTDLG));
    pdlg.lStructSize = sizeof(PRINTDLG);
    pdlg.Flags = PD_PRINTSETUP | PD_RETURNDC;

    ::PrintDlg(&pdlg);

	WLDEBUGMSG(L"pdlg.hDC = 0x%x\n", pdlg.hDC);
    return pdlg.hDC;
}

static void initDocStruct(DOCINFO* di, TCHAR* docname)
{
    memset(di, 0, sizeof(DOCINFO));
    di->cbSize = sizeof(DOCINFO);
    di->lpszDocName = docname;
}

void PrintView(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HDC printDC = getPrinterDC();
	WLDEBUGMSG(L"printDC = 0x%x\n", printDC);
    if (!printDC) {
        ::MessageBoxW(0, L"Error creating printing DC", L"Error", MB_APPLMODAL | MB_OK);
        return;
    }

    if (::SetAbortProc(printDC, AbortProc) == SP_ERROR) {
        ::MessageBoxW(0, L"Error setting up AbortProc", L"Error", MB_APPLMODAL | MB_OK);
        return;
    }

    IWebFrame* frame = 0;
    IWebFramePrivate* framePrivate = 0;
    if (FAILED(gWebView->mainFrame(&frame)))
        goto exit;

    if (FAILED(frame->QueryInterface(&framePrivate)))
        goto exit;

    framePrivate->setInPrintingMode(TRUE, (int)printDC);

    UINT pageCount = 0;
    framePrivate->getPrintedPageCount((int)printDC, &pageCount);
	WLDEBUGMSG(L"pageCount = %d\n", pageCount);

    DOCINFO di;
    initDocStruct(&di, L"WebKit Doc");
    int iJobId = ::StartDoc(printDC, &di);
	WLDEBUGMSG(L"JobId = %d\n", iJobId);
    if (iJobId == SP_ERROR) {
        ::MessageBoxW(0, L"Error StartDoc", L"Error", MB_APPLMODAL | MB_OK);
        goto exit;
    }

    // FIXME: Need CoreGraphics implementation
    void* graphicsContext = 0;
    for (size_t page = 1; page <= pageCount; ++page) {
        ::StartPage(printDC);
        framePrivate->spoolPages((int)printDC, page, page, graphicsContext);
        ::EndPage(printDC);
    }

    framePrivate->setInPrintingMode(FALSE, (int)printDC);

    ::EndDoc(printDC);
    ::DeleteDC(printDC);

exit:
    if (frame)
        frame->Release();
    if (framePrivate)
        framePrivate->Release();
}

static int MyMessageBox(HWND hWndp, LPCWSTR lpText, LPCWSTR lpCaption, UINT uType) {
	static bool bOpenMessageBox = false;
	if (bOpenMessageBox) return 0;
	bOpenMessageBox = true;
	int rVal = ::MessageBoxW(hWndp, lpText, lpCaption, uType);
	bOpenMessageBox = false;
	return rVal;
}

static void GarbageCollect() {
	IWebJavaScriptCollector* tmpCollector = 0;
	if (FAILED(WebKitCreateInstance(CLSID_WebJavaScriptCollector, 0, IID_IWebJavaScriptCollector, reinterpret_cast<void**>(&tmpCollector)))) {
		MYDEBUGMSG(L"Failed create IWebJavaScriptCollector!\n");
		return;
	}
	if (FAILED(tmpCollector->collect())) {
		MYDEBUGMSG(L"Failed collect!\n");
	}
	if (tmpCollector) tmpCollector->Release();
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    WNDPROC parentProc = usesLayeredWebView() ? DefWebKitProc : DefWindowProc;

    switch (message) {
	case WM_CREATE:
		{
			if (strLen) g_nIDEvent = SetTimer(hWnd, TIMER_ID1, 1000, NULL);
		}
		break;
	case WM_ERR_WININET:
		{
			TCHAR mbuf[256];
			_stprintf_s(mbuf, 256, _T("Error WinInet code = %d, loadtype = %d\n(see WinInet.h or IWebError.idl for the detail of code)"), lParam, wParam);
			MyMessageBox(hWnd, mbuf, L"Error", MB_APPLMODAL | MB_OK);
		}
		break;
	case WM_ERR_UIDELEGATE:
		MyMessageBox(hWnd, L"Not support to open new window.", L"Error", MB_APPLMODAL | MB_OK);
		break;
    case WM_NCHITTEST:
        if (usesLayeredWebView()) {
            RECT window;
            ::GetWindowRect(hWnd, &window);
            // For testing our transparent window, we need a region to use as a handle for
            // dragging. The right way to do this would be to query the web view to see what's
            // under the mouse. However, for testing purposes we just use an arbitrary
            // 30 pixel band at the top of the view as an arbitrary gripping location.
            //
            // When we are within this bad, return HT_CAPTION to tell Windows we want to
            // treat this region as if it were the title bar on a normal window.
            int y = HIWORD(lParam);

            if ((y > window.top) && (y < window.top + dragBarHeight))
                return HTCAPTION;
        }
        return CallWindowProc(parentProc, hWnd, message, wParam, lParam);
    case WM_COMMAND: {
        int wmId = LOWORD(wParam);
        int wmEvent = HIWORD(wParam);
        // Parse the menu selections:
        switch (wmId) {
        case IDM_ABOUT:
            DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
            break;
        case IDM_EXIT:
            DestroyWindow(hWnd);
            break;
        case IDM_PRINT:
            PrintView(hWnd, message, wParam, lParam);
            break;
        case IDM_INSPECTOR:
			gWebInspector->show();
            break;
        case IDM_COLLECT:
			GarbageCollect();
            break;
		case IDM_YAHOO:
			{
				WLDEBUGMSG(L"YahooTest(No Delay) Start\n");
				iYahooMode = 1;
				BSTR bstr = SysAllocString(g_szLocalTestUrl);
				loadURL(bstr);
				SysFreeString(bstr);
			}
			break;
		case IDM_YAHOO1S:
			{
				WLDEBUGMSG(L"YahooTest(1s Delay) Start\n");
				iYahooMode = 2;
				BSTR bstr = SysAllocString(g_szLocalTestUrl);
				loadURL(bstr);
				SysFreeString(bstr);
			}
			break;
		case IDM_JAVASC3S:
			{
				g_nIDEvent = SetTimer(hMainWnd, TIMER_ID3, 3000, NULL);

			}
			break;
		case IDM_CAPTURE:
			{
				if (posTestSite == -1) {
					MYDEBUGMSG(L"Auto Capture Start\n");
					posTestSite = 0;
					cntLoopTestSite = 0;
					iYahooMode = 3;
					BSTR bstr = SysAllocString(urlTestSite[posTestSite]);
					iFinishLoadForFrame = 0;
					loadURL(bstr);
					SysFreeString(bstr);
					g_nIDEvent = SetTimer(hMainWnd, TIMER_ID4, 90000, NULL);	// didFinishLoadForFrameȂꍇ̂
				} else {
					MYDEBUGMSG(L"Auto Capture Stop\n");
					iFinishLoadForFrame = 0;
					KillTimer(hWnd, TIMER_ID4);
					g_nIDEvent = 0;
					posTestSite = -1;
				}
			}
			break;
		case IDM_LOOP:
			g_nIDEvent = SetTimer(hWnd, TIMER_ID1, 4000, NULL);
//			MYDEBUGMSG(L"SetTimer\n");
			break;
		case IDM_HOME:
//			MYDEBUGMSG(L"GoHome\n");
			LoadHtmlInitString();
			break;
		case IDM_ZOOMIN:
			{
				BOOL bCan;
				gWebActions->canZoomPageIn(NULL, &bCan);
				WLDEBUGMSG(L"IDM_ZOOMIN bCan = %d\n", bCan);
				if (bCan) {
					gWebActions->zoomPageIn(NULL);
				} else {
					MyMessageBox(hWnd, L"Can't ZoomPageIn any more!", L"Error", MB_APPLMODAL | MB_OK);
				}
			}
			break;
		case IDM_ZOOMOUT:
			{
				BOOL bCan;
				gWebActions->canZoomPageOut(NULL, &bCan);
				WLDEBUGMSG(L"IDM_ZOOMOUT bCan = %d\n", bCan);
				if (bCan) {
					gWebActions->zoomPageOut(NULL);
				} else {
					MyMessageBox(hWnd, L"Can't zoomPageOut any more!", L"Error", MB_APPLMODAL | MB_OK);
				}
			}
			break;
		case IDM_ZOOMDEF:
			{
				BOOL bCan;
				gWebActions->canResetPageZoom(NULL, &bCan);
				WLDEBUGMSG(L"IDM_ZOOMDEF bCan = %d\n", bCan);
				if (bCan) {
					gWebActions->resetPageZoom(NULL);
				} else {
					MyMessageBox(hWnd, L"Can't ResetPageZoom!", L"Error", MB_APPLMODAL | MB_OK);
				}

			}
			break;
		case IDM_TEXTLARGER:
			{
				BOOL bCan;
				gWebActions->canMakeTextLarger((IUnknown*)1, &bCan);
				WLDEBUGMSG(L"IDM_TEXTLARGER bCan = %d\n", bCan);
				if (bCan) {
					gWebActions->makeTextLarger((IUnknown*)1);
				} else {
					MyMessageBox(hWnd, L"Can't makeTextLarger any more!", L"Error", MB_APPLMODAL | MB_OK);
				}
			}
			break;
		case IDM_TEXTSMALLER:
			{
				BOOL bCan;
				gWebActions->canMakeTextSmaller((IUnknown*)1, &bCan);
				WLDEBUGMSG(L"IDM_TEXTSMALLER bCan = %d\n", bCan);
				if (bCan) {
					gWebActions->makeTextSmaller((IUnknown*)1);
				} else {
					MyMessageBox(hWnd, L"Can't makeTextSmaller any more!", L"Error", MB_APPLMODAL | MB_OK);
				}
			}
			break;
		case IDM_TEXTNORMAL:
			{
				BOOL bCan;
				gWebActions->canMakeTextStandardSize(NULL, &bCan);
				WLDEBUGMSG(L"IDM_TEXTNORMAL bCan = %d\n", bCan);
				if (bCan) {
					gWebActions->makeTextStandardSize(NULL);
				} else  {
					MyMessageBox(hWnd, L"Can't makeTextStandardSize!", L"Error", MB_APPLMODAL | MB_OK);
				}
			}
			break;
		case IDM_SETPAGESIZE:
			gWebActions->setPageSizeMultiplier(1.5);
			break;
		case IDM_FONTTIMES:
			{
				TCHAR stdfont[] = L"Times New Roman";
				BSTR bstStdFont = SysAllocString(stdfont);
				standardPreferences->setStandardFontFamily(bstStdFont);
				SysFreeString(bstStdFont);
			}
			break;
		case IDM_FONTSIMHEI:
			{
				TCHAR stdfont[] = L"SimHei";
				BSTR bstStdFont = SysAllocString(stdfont);
				standardPreferences->setStandardFontFamily(bstStdFont);
				SysFreeString(bstStdFont);
			}
			break;
        default:
            return CallWindowProc(parentProc, hWnd, message, wParam, lParam);
        }
        }
        break;
	case WM_TIMER:
		{
			if (wParam == TIMER_ID2) {
				KillTimer(hWnd, TIMER_ID2);
				g_nIDEvent = 0;
				BSTR testUrl = SysAllocString(g_szLocalTestUrl);
				loadURL(testUrl);
				SysFreeString(testUrl);
			} else if (wParam == TIMER_ID3) {
				KillTimer(hWnd, TIMER_ID3);
				TCHAR mbuf[] = L"javascript: var f = document.createElement('form'); f.setAttribute('action','http://www.schoin.org/hanyu/hanzi/index.jsp'); f.setAttribute('method','post'); f.setAttribute('id','f0'); f.style.display='none'; var i = document.createElement('input'); i.setAttribute('name','word'); i.setAttribute('value','han4'); f.appendChild(i); var i = document.createElement('input'); i.setAttribute('name', 'direction'); i.setAttribute('value', ''); f.appendChild(i); document.getElementsByTagName('body')[0].appendChild(f); f.submit(); ";
				BSTR testJs = SysAllocString(mbuf);
				BSTR testResult = SysAllocString(g_szLocalTestUrl);
			    gWebView->stringByEvaluatingJavaScriptFromString(testJs, &testResult);
				SysFreeString(testResult);
				SysFreeString(testJs);
			} else if (wParam == TIMER_ID4) {
				KillTimer(hWnd, TIMER_ID4);
				if (posTestSite == -1) return 0;
				if (iFinishLoadForFrame == 0) {
					MYDEBUGMSG(L"not yet FinishLoadForFrame!!\n");
				}
				g_nIDEvent = 0;
				if (iCaptureEnable) {
					DWORD iTick = GetTickCount();
					MYDEBUGMSG(L"start snapShot LOOP:%d site = %s\n", cntLoopTestSite, urlTestSite[posTestSite]);
					VARIANT vrCapbuf;
					VariantInit(&vrCapbuf); 
					gWebView->snapShot(&vrCapbuf);
					gWebView->clearSnapShot(&vrCapbuf);
					VariantClear(&vrCapbuf);
					MYDEBUGMSG(L"finish snapShot proc time = %d ms\n", (GetTickCount() - iTick));
				} else {
					MYDEBUGMSG(L"without snapShot LOOP:%d site = %s\n", cntLoopTestSite, urlTestSite[posTestSite]);
				}
				posTestSite++;
				if (posTestSite >= cntTestSite) {
					posTestSite = 0;
					cntLoopTestSite++;
					if (cntLoopTestSite == 1 || GetFileAttributesA("C:\\Windows\\PauseForUMDH.txt") != 0xFFFFFFFF) {
						GarbageCollect();
						MyMessageBox(hWnd, L"Please execute UMDH now! And get ready to put C:\\Windows\\PauseForUMDH.txt.", L"UMDH", MB_APPLMODAL | MB_OK);
					}
				}
				BSTR testUrl = SysAllocString(urlTestSite[posTestSite]);
				iFinishLoadForFrame = 0;
				loadURL(testUrl);
				SysFreeString(testUrl);
				g_nIDEvent = SetTimer(hMainWnd, TIMER_ID4, 90000, NULL);	// didFinishLoadForFrameȂꍇ̂
			} else {
				KillTimer(hWnd, TIMER_ID1);
				BSTR bstr = SysAllocStringLen(strPtr, strLen);
//				MYDEBUGMSG(L"TimeOut\n");
				loadURL(bstr);
				SysFreeString(bstr);
			}
		}
		break;
    case WM_DESTROY:
		KillTimer(hWnd, 1);
		if (g_nIDEvent != 0) {
			KillTimer(hWnd, g_nIDEvent);
		}
		if (gWebInspector) {
			gWebInspector->close();
			gWebInspector->detach();
		}
		if (bstUserAgent) SysFreeString(bstUserAgent);
		if (bstUserAgentSpecial1) SysFreeString(bstUserAgentSpecial1);
		clearHeap();

        PostQuitMessage(0);
        break;
    case WM_SIZE:
        if (!gWebView || usesLayeredWebView())
           return CallWindowProc(parentProc, hWnd, message, wParam, lParam);

        resizeSubViews();
        break;
    default:
        return CallWindowProc(parentProc, hWnd, message, wParam, lParam);
    }

    return 0;
}

BOOL GetBaseUrlPath(LPTSTR lpszUrl, DWORD dwSize)
{
#if USE_INTERNET_URL
	_tcscpy_s(lpszUrl, dwSize, _T("http://www.yahoo.com/"));
	return TRUE;
#else
	BOOL bRet = FALSE;
	TCHAR* pszDir = NULL;

	if (!lpszUrl || dwSize == 0) {
		goto exit;
	}

	pszDir = new TCHAR[dwSize];
	if (!pszDir) {
		goto exit;
	}

	if (GetModuleFileName(NULL, pszDir, dwSize) == 0) {
		goto exit;
	}

	TCHAR* pLast = _tcsrchr(pszDir, _T('\\'));
	if (!pLast) {
		goto exit;
	}
	*pLast = _T('\0');

	int i = 0;
	while (pszDir[i] != _T('\0')) {
		if (pszDir[i] == _T('\\')) {
			pszDir[i] = _T('/');
		}
		i++;
	}

	_tcscat_s(lpszUrl, dwSize, _T("file://localhost/"));
	_tcscat_s(lpszUrl, dwSize, pszDir);
	_tcscat_s(lpszUrl, dwSize, _T("/yahoo/Yahoo.htm"));

	bRet = TRUE;

exit:
	if (pszDir) {
		delete pszDir;
	}
	return bRet;
#endif
}

LRESULT CALLBACK MyEditProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message) {
        case WM_CHAR:
            if (wParam == 13) { // Enter Key
                *((LPWORD)strPtr) = MAX_URL_LENGTH; 
                strLen = SendMessage(hDlg, EM_GETLINE, 0, (LPARAM)strPtr);

                BSTR bstr = SysAllocStringLen(strPtr, strLen);
                loadURL(bstr);
                SysFreeString(bstr);
                return 0;
            } else
                return (LRESULT)CallWindowProc((WNDPROC)DefEditProc,hDlg,message,wParam,lParam);
            break;
        default:
             return (LRESULT)CallWindowProc((WNDPROC)DefEditProc,hDlg,message,wParam,lParam);
        break;
    }
}


// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    UNREFERENCED_PARAMETER(lParam);
    switch (message) {
    case WM_INITDIALOG:
        return (INT_PTR)TRUE;

    case WM_COMMAND:
        if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) {
            EndDialog(hDlg, LOWORD(wParam));
            return (INT_PTR)TRUE;
        }
        break;
    }
    return (INT_PTR)FALSE;
}

static void loadURL(BSTR urlBStr)
{
    IWebFrame* frame = 0;
    IWebMutableURLRequest* request = 0;

    // static BSTR methodBStr = SysAllocString(TEXT("GET"));
    BSTR methodBStr = SysAllocString(TEXT("GET"));

    if (urlBStr && urlBStr[0] && (PathFileExists(urlBStr) || PathIsUNC(urlBStr))) {
        TCHAR fileURL[INTERNET_MAX_URL_LENGTH];
        DWORD fileURLLength = sizeof(fileURL)/sizeof(fileURL[0]);

        if (SUCCEEDED(UrlCreateFromPath(urlBStr, fileURL, &fileURLLength, 0)))
            SysReAllocString(&urlBStr, fileURL);
    }

    HRESULT hr = gWebView->mainFrame(&frame);
    if (FAILED(hr))
        goto exit;

    hr = WebKitCreateInstance(CLSID_WebMutableURLRequest, 0, IID_IWebMutableURLRequest, (void**)&request);
    if (FAILED(hr))
        goto exit;

    hr = request->initWithURL(urlBStr, WebURLRequestUseProtocolCachePolicy, 60);
//    hr = request->initWithURL(urlBStr, WebURLRequestReloadIgnoringCacheData, 60);
    if (FAILED(hr))
        goto exit;

    hr = request->setHTTPMethod(methodBStr);
    if (FAILED(hr))
        goto exit;

    hr = frame->loadRequest(request);
    if (FAILED(hr))
        goto exit;

    SetFocus(gViewWindow);

exit:
	if (methodBStr) SysFreeString(methodBStr);

    if (frame)
        frame->Release();
    if (request)
        request->Release();
}
